extern Err PlugLib_open(UInt16 refnum);
extern Err PlugLib_close(UInt16 refnum, UInt16 * numappsP);
extern Err PlugLib_sleep(UInt16 refnum);
extern Err PlugLib_wake(UInt16 refnum);
extern UInt32 PlugLib_getVersion(UInt16 refnum);
extern void PlugLib_showAboutBox(UInt16 refnum);
extern DataSourceDriver * PlugLib_getDriver(UInt16 refnum);
extern void * PlugLib_getAction(UInt16 refnum, UInt16 action);

extern char PlugLibName[];

// Define this so we don't use the Palm OS pre-compiled headers.
// We can't use them here because we re-define some build options
#ifndef PILOT_PRECOMPILED_HEADERS_OFF
#define	PILOT_PRECOMPILED_HEADERS_OFF
#endif


// Define EMULATION_LEVEL.  __PALMOS_TRAPS__ was pre-defined by MW C Compiler
// Test it before we blow it away so we can properly define EMULATION_LEVEL.
#if __PALMOS_TRAPS__
		#define EMULATION_LEVEL		EMULATION_NONE		// building Pilot executable
#endif

// Now clear __PALMOS_TRAPS__ and define USE_TRAPS so headers do the right thing
// That is, we need to be able to get the addresses of SampleLibrary routines.
// Other modules will access the routines through traps.
#undef __PALMOS_TRAPS__
#define __PALMOS_TRAPS__ 	0
#define	USE_TRAPS 	0


// Include Pilot headers
#include <PalmOS.h>

/************************************************************
 *
 *  FUNCTION: Dispatch Table for Sample Library
 *
 *  DESCRIPTION: This table gets installed into the dispatchTblP
 *		field of the library entry in the library table. It gives
 *		the 16-bit offset of every routine relative to the start of
 *		the dispatch table.
 *
 *  WARNING!!! This table must match the ordering of the library's
 *		trap numbers!!!!!!!!!!
 *
 *  CREATED: 5/19/97
 *
 *  BY: vmk
 *
 *************************************************************/

// First, define the size of the jump instruction
#if EMULATION_LEVEL == EMULATION_NONE
	#define prvJmpSize		4					// Palm OS presently uses short jumps
#elif EMULATION_LEVEL == EMULATION_MAC
	#define prvJmpSize		6					// Our Mac builds use long jumps
#else
	#error unsupported emulation mode
#endif	// EMULATION_LEVEL...

// Now, define a macro for offset list entries
#define libDispatchEntry(index)		(kOffset+((index)*prvJmpSize))


// Finally, define the size of the dispatch table's offset list --
// it is equal to the size of each entry (which is presently 2 bytes) times
// the number of entries in the offset list (***including the @Name entry***).
//
#define	kOffset		(2*9)						// NOTE: This is empirical!!!!!!
														// Will change when table changes!!

void * asm jmptable ()
{
	LEA		@Table, A0								// table ptr
	RTS													// exit with it

@Table:
	// Offset to library name
	DC.W		@Name
	
	//
	// Library function dispatch entries
	//
	// ***IMPORTANT***
	// The index parameters passed to the macro libDispatchEntry
	// must be numbered consecutively, beginning with zero.
	//
	// The hard-wired values need to be used for offsets because the MW SDK tools do
	// not support label subtraction.
	//
	
	// Standard traps
	DC.W		libDispatchEntry(0)					// Open
	DC.W		libDispatchEntry(1)					// Close
	DC.W		libDispatchEntry(2)					// Sleep
	DC.W		libDispatchEntry(3)					// Wake
	
	// Start of the Custom traps
	DC.W		libDispatchEntry(4)					// PlugLib_getVersion
	DC.W		libDispatchEntry(5)					// PlugLib_showAboutBox
	DC.W		libDispatchEntry(6)					// PlugLib_getDriver
	DC.W		libDispatchEntry(7)					// PlugLib_getAction

// Standard library function handlers
@GotoOpen:
	JMP 		PlugLib_open
@GotoClose:
	JMP 		PlugLib_close
@GotoSleep:
	JMP 		PlugLib_sleep
@GotoWake:
	JMP 		PlugLib_wake
	
// Customer library function handlers
@GotoGetLibAPIVersion:
	JMP 		PlugLib_getVersion
@GotoSetCornerDiameter:
	JMP 		PlugLib_showAboutBox
@GotoGetCornerDiameter:
	JMP 		PlugLib_getDriver
@GotoDrawRectangle:
	JMP		    PlugLib_getAction

@Name:
	DC.B		PlugLibName							// This name identifies the library.  Apps
															// can pass it to SysLibFind() to check if the
															// library is already installed
	
}
