#include <PalmOS.h>

#include "PlugLib.h"
#include "plugin.h"
#include "enum-informations.h"
#include "datasource.h"

void MyCallBack( void *plugData)
{
	UInt16 cardNo;
	LocalID dbID;
	UInt32 records, totalBytes;
	char recs[10], invis[10], bytes[10];
    DataSource * source = Plug_GetSource(plugData);

	if ( source ) {

		source->ops.Info( source, &cardNo, &dbID, NULL, NULL, &records, &totalBytes );

		StrIToA( recs, records );
		if ( totalBytes > 0x1000 ) {
			StrPrintF( bytes, "%ldK", totalBytes/1024 );
		}
		else {
			StrIToA( bytes, totalBytes );
		}


		// we're just reusing totalBytes, its really going to contain 
		// the total number of records
		DmDatabaseSize( cardNo, dbID, &totalBytes, NULL, NULL );
		totalBytes -= records;
		StrIToA( invis, totalBytes );

		FrmCustomAlert(alertID_InfoBox, recs, invis, bytes);
	}

}

void MainPlug(void *plugData)
{
    Plug_SetDriver(plugData, NULL);
    Plug_SetAction(plugData, ActionRunInListViewSelector, MyCallBack);
	Plug_SetAboutAlert(plugData, alertID_AboutBox);
}
