#include <PalmOS.h>

#include "PlugLib.h"
#include "plugin.h"
#include "enum-report.h"
#include "datasource.h"
#include "display.h"


#define GetObjectPtr(f,i) FrmGetObjectPtr((f),FrmGetObjectIndex((f),(i)))

extern void printReport( DataSource *source, UInt16 field, char *buff );

#define SAVE 4
#define TEXT_SIZE 200


void MyCallBack( void *plugData)
{



    DataSource * source = Plug_GetSource(plugData);
	UInt16 i;
	PersistentData *pd;
	Char *s;
	
	if ( source ) {
		
		pd = MemPtrNew( sizeof( PersistentData ) );
		pd->n = source->schema.numFields;
		pd->fields = MemPtrNew( pd->n * sizeof( char * ) );
		pd->source = source;

		pd->note.h = NULL;
		pd->note.title[0] = 'R';
		pd->note.title[1] = 'e';
		pd->note.title[2] = 'p';
		pd->note.title[3] = 'o';
		pd->note.title[4] = 'r';
		pd->note.title[5] = 't';
		pd->note.title[6] = '\0';
		
		
		for( i = 0; i < pd->n; i++ ) {
			pd->fields[i] = MemPtrNew(StrLen(source->schema.fields[i].name) + 1);
			StrCopy( pd->fields[i], source->schema.fields[i].name );
		}
        pd->note.h = MemHandleNew(256);
        s = (Char *)MemHandleLock(pd->note.h);
        s[0] = '\0';
        MemHandleUnlock(pd->note.h);


		DisplayPopupForm( pd );
		for( i = 0; i < pd->n; i++ ) {
			MemPtrFree(pd->fields[i]);
		}
		MemPtrFree( pd->fields );
		MemHandleFree( pd->note.h );
		MemPtrFree( pd );

	}
/*
	FormPtr form, oldForm;
	Boolean done;

	UInt16 nf, i, j, count;
	char *str;
	MemHandle h;
	char **fields;
	FieldPtr fld;
	MemHandle hs[SAVE];
	UInt16 hsIndex[SAVE];


	if ( source ) {
		
		oldForm = FrmGetActiveForm();
		form = FrmInitForm( formID_Report );
		FrmSetActiveForm( form );

		count = 0;

		nf = source->schema.numFields;

		list = GetObjectPtr( form, ctlID_Report_FieldList );
		
		fields = MemPtrNew( nf * sizeof( char * ) );
		
		for( i = 0; i < nf; i++ ) {
			fields[i] = MemPtrNew( StrLen(source->schema.fields[i].name) + 1 );
			StrCopy( fields[i], source->schema.fields[i].name );
		}
		LstSetListChoices( list, fields, nf );
		LstSetHeight( list, (nf>5)?5:nf );
		LstSetSelection( list, noListSelection );
	
		for( i = 0; i < SAVE; i++ ) {
			hsIndex[i] = 0xffff;
			hs[i] = NULL;
		}

		done = false;
		while( !done ) {
			i = LstGetSelection( list );

			if ( i == noListSelection ) {
				fld = GetObjectPtr( form, ctlID_Report_Display );
				h = FldGetTextHandle( fld );
				if ( h == NULL ) 
					h = MemHandleNew( TEXT_SIZE );
				str = MemHandleLock( h );
				StrCopy( str, "Select a field an press 'Refresh'..." );
				MemHandleUnlock( h );
				FldSetTextHandle( fld, h );
				hs[0] = h;
			}
			else if ( i < nf) {

				fld = GetObjectPtr( form, ctlID_Report_Display );
				
				for( j = 0; j < SAVE; j++ ) {
					if ( hsIndex[j] == i )
						break;
				}
				if ( j < SAVE ) {
					FldSetTextHandle( fld, hs[j] );
				}
				else {
					h = hs[count % SAVE];

					hs[count % SAVE] = MemHandleNew( TEXT_SIZE );
					hsIndex[count % SAVE] = i;
					
					// run report
					str = MemHandleLock( hs[count % SAVE] );
					
					printReport( source, i, str );

					MemHandleUnlock( hs[count % SAVE] );
					FldSetTextHandle( fld, hs[count % SAVE] );
					if ( h != NULL) MemHandleFree( h );
					count++;
				}
			
			}
			if ( FrmDoDialog( form ) != ctlID_Report_Refresh ) 
				done = true;

		}
		
		fld = GetObjectPtr( form, ctlID_Report_Display );
		h = FldGetTextHandle( fld );
		FldSetTextHandle( fld, NULL );

		FrmDeleteForm( form );
		FrmSetActiveForm( oldForm );
		for( i = 0; i < nf; i++ )
			MemPtrFree( fields[i] );
		MemPtrFree( fields );
		
		for( i = 0; i < SAVE; i++ )
			if ( hs[i] != NULL ) MemHandleFree( hs[i] );


	}
*/
}
void MainPlug(void *plugData)
{
    Plug_SetAboutAlert(plugData, alertID_AboutBox);
    Plug_SetAction(plugData, ActionRunInListViewSelector, MyCallBack);
}
